---------------------
-- Merchants v0.01 --
---------------------
if Mers == nil then Mers = {} end

-- strings for localization
Mers.moreInfo = { 
    --Extra info
	[1] = "Inside City",
	[2] = "Solo dungeon",
	[3] = "Public dungeon",
	[4] = "Inside Cave",
	[5] = "Walks along the road to Ebonheart",-- lo-lo
	[6] = "Walks along the road to Senie",
	[7] = "Walks along the road to Kragenmoor",-- lo-lo
	[8] = "Basement",
	[9] = "Inside Building",
	[10] = "Supplier",--unused so far (maybe for Silver-Gills, Merchant)
	[11] = "Walks along the road to Fort Virak",-- Wemeerit
	[12] = "Walks along the road to Heimlyn Keep",-- Wemeerit
	[13] = "Stops Here",
	[14] = "Walks along the road to Sulfur Pools",
	[15] = "Walks along the road to Lukiul Uxith",
	[16] = "Walks along the road to Ash Mountain",
	[17] = "Walks along the road to Davon's Watch",
	[18] = "Walks Around",
	[19] = "Upstairs",
	[20]= "Disappears if village is freed(unchecked)",
	--NPC Types
	[21] = "Alchemist",
	[22] = "Armorer",
	[23] = "Blacksmith",
	[24] = "Clothier",
	[25] = "Grocer",
	[26] = "Leatherworker",
	[27] = "Merchant",
	[28] = "Mystic",
	[29] = "BackPack Merchant",
	[30] = "Tailor",
	[31] = "Weaponsmith",
	[32] = "Woodworker",
	[33] = "Chef",
	[34] = "Brewer",
	[35] = "Enchanter",
	[36] = "Innkeeper",
	[37] = "Magus",
	[38] = "Banker",
	[39] = "Carpenter",
	[40] = "Armsman",
	[41] = "Stablemaster",
	[42] = "Magister",
	[50] = "Walks along the road to Stormhold",
	[51] = "Walks along the road to Ten-Maur-Wolk",
	[52] = "Walks along the road to Hissmir",
	[53] = "Walks along the road to White Rose Prison",
}

-- default settings for saved variables
Mers.defaults = {
    --sizeMerchant = 25,
    showAlchemist = true,
	showArmorer = true,
	showArmsman = true,
	showBanker = true,
	showBlacksmith = true,
	showBrewer = true,
	showCarpenter = true,
	showChef = true,
	showClothier = true,
	showEnchanter = true,
	showGrocer = true,
	showInnKeeper = true,
	showLeatherworker = true,
	showMagus = true,
	showMagister = true,
	showMerchant = true,
	showMystic = true,
    showPackMerchant = true,
	showStablemaster = true,
	showTailor = true,
	showWeaponsmith = true,
	showWoodworker = true,
}

-- Pins
-- USE "/iv" INGAME TO SEE ICONS , at 718 map starts
Mers.pinLayout_Alchemist = { 
	level = 40,
	texture = "/esoui/art/progression/icon_alchemist.dds",
	size = 25,
}

Mers.pinLayout_Armorer = { 
	level = 40,
	texture = "/esoui/art/progression/icon_armorsmith.dds",
	size = 25,
}

Mers.pinLayout_Armsman = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Banker = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Blacksmith = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Brewer = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Carpenter = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Chef = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Clothier = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Grocer = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Leatherworker = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_InnKeeper = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Enchanter = { 
	level = 40,
	texture = "/esoui/art/progression/icon_enchanter.dds",
	size = 25,
}

Mers.pinLayout_Magus = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Magister = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Merchant = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Mystic = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_PackMerchant = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Stablemaster = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Tailor = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

Mers.pinLayout_Weaponsmith = { 
	level = 40,
	texture = "/esoui/art/progression/icon_weaponsmith.dds",
	size = 25,
}

Mers.pinLayout_Woodworker = { 
	level = 40,
	texture = "/esoui/art/mappins/compassvendor.dds",
	size = 25,
}

--Handles info on NPC
local function GetInfoFromTag(pin)
	local _, pinTag = pin:GetPinTypeAndTag()
	local npcname = pinTag[3] --NPC Name
	local npctype = Mers.moreInfo[pinTag[4]] --Type NPC 
	if pinTag[5] ~= nil and pinTag[6] == nil and pinTag[7] == nil then
	     local description = "[" .. Mers.moreInfo[pinTag[5]] .. "]" 
		 return npcname, npctype, description
	elseif pinTag[5] ~= nil and pinTag[6] ~= nil and pinTag[7] == nil then
	     local description = "[" .. Mers.moreInfo[pinTag[5]] .. "]" 
	     local moredescription = "[" .. Mers.moreInfo[pinTag[6]] .. "]"
		 return npcname, npctype, description, moredescription
	elseif pinTag[5] ~= nil and pinTag[6] ~= nil and pinTag[7] ~= nil then	 
		 local description = "[" .. Mers.moreInfo[pinTag[5]] .. "]" 
	     local moredescription = "[" .. Mers.moreInfo[pinTag[6]] .. "]"
		 local evenmoredescription = "[" .. Mers.moreInfo[pinTag[7]] .. "]"
		 return npcname, npctype, description, moredescription, evenmoredescription
	else
		 return npcname, npctype
	end
end

--Creates ToolTip from NPC info
Mers.pinTooltipCreator = {
	creator = function(pin)
		local npcname, npctype, description, moredescription, evenmoredescription = GetInfoFromTag(pin)
		InformationTooltip:AddLine(npcname, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())--name color
		InformationTooltip:AddLine(npctype, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())--type color
		if description ~= nil and moredescription == nil and evenmoredescription == nil then
		     InformationTooltip:AddLine(description, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
	    elseif description ~= nil and moredescription ~= nil and evenmoredescription == nil then
			 InformationTooltip:AddLine(description, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
		     InformationTooltip:AddLine(moredescription, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
		elseif description ~= nil and moredescription ~= nil and evenmoredescription ~= nil then
		     InformationTooltip:AddLine(description, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
		     InformationTooltip:AddLine(moredescription, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
			 InformationTooltip:AddLine(evenmoredescription, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
		end
	end,
	tooltip = InformationTooltip,
}
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--Handles icon placement on maps for Alchemist
function Mers.pinCreator_Alchemist(pinManager)
    if not Mers.SavedVariables.showAlchemist then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.AlchemistData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Alchemist"], pinData, pinData[1], pinData[2])
	end
end
	
--Handles icon placement on maps for Armorers
function Mers.pinCreator_Armorer(pinManager)
    if not Mers.SavedVariables.showArmorer then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.ArmorerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Armorer"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Armsmen
function Mers.pinCreator_Armsman(pinManager)
    if not Mers.SavedVariables.showArmsman then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.ArmsmanData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Armsman"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Bankers
function Mers.pinCreator_Banker(pinManager)
    if not Mers.SavedVariables.showBanker then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.BankerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Banker"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Blacksmiths
function Mers.pinCreator_Blacksmith(pinManager)
    if not Mers.SavedVariables.showBlacksmith then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.BlacksmithData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Blacksmith"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Brewers
function Mers.pinCreator_Brewer(pinManager)
    if not Mers.SavedVariables.showBrewer then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.BrewerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Brewer"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Carpenters
function Mers.pinCreator_Carpenter(pinManager)
    if not Mers.SavedVariables.showCarpenter then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.CarpenterData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Carpenter"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Chefs
function Mers.pinCreator_Chef(pinManager)
    if not Mers.SavedVariables.showChef then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.ChefData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Chef"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Clothiers
function Mers.pinCreator_Clothier(pinManager)
    if not Mers.SavedVariables.showClothier then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.ClothierData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Clothier"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Grocers
function Mers.pinCreator_Grocer(pinManager)
    if not Mers.SavedVariables.showGrocer then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.GrocerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Grocer"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Leatherworkers
function Mers.pinCreator_Leatherworker(pinManager)
    if not Mers.SavedVariables.showLeatherworker then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.LeatherworkerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Leatherworker"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Enchanters
function Mers.pinCreator_Enchanter(pinManager)
    if not Mers.SavedVariables.showEnchanter then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.EnchanterData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Enchanter"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for InnKeepers
function Mers.pinCreator_InnKeeper(pinManager)
    if not Mers.SavedVariables.showInnKeeper then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.InnKeeperData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_InnKeeper"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Maguses
function Mers.pinCreator_Magus(pinManager)
    if not Mers.SavedVariables.showMagus then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.MagusData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Magus"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Magisters
function Mers.pinCreator_Magister(pinManager)
    if not Mers.SavedVariables.showMagister then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.MagisterData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Magister"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Merchants
function Mers.pinCreator_Merchant(pinManager)
    if not Mers.SavedVariables.showMerchant then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.MerchantData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Merchant"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Mystics
function Mers.pinCreator_Mystic(pinManager)
    if not Mers.SavedVariables.showMystic then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.MysticData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Mystic"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Packmerchants
function Mers.pinCreator_PackMerchant(pinManager)
    if not Mers.SavedVariables.showPackMerchant then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.PackMerchantData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_PackMerchant"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Stablemasters
function Mers.pinCreator_Stablemaster(pinManager)
    if not Mers.SavedVariables.showStablemaster then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.StablemasterData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Stablemaster"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Tailors
function Mers.pinCreator_Tailor(pinManager)
    if not Mers.SavedVariables.showTailor then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.TailorData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Tailor"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Weaponsmiths
function Mers.pinCreator_Weaponsmith(pinManager)
    if not Mers.SavedVariables.showWeaponsmith then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.WeaponsmithData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Weaponsmith"], pinData, pinData[1], pinData[2])
	end
end

--Handles icon placement on maps for Woodworkers
function Mers.pinCreator_Woodworker(pinManager)
    if not Mers.SavedVariables.showWoodworker then return end -- if true in saved variables
	
	local subzone = GetMapName() --Stock current map name in a variable
	local merchants = Mers.WoodworkerData[subzone] --Get that map's info from MerchantsData.lua & stock it in a variable 
	if not merchants then return end

	for _, pinData in pairs(merchants) do
		pinManager:CreatePin( _G["MersMapPin_Woodworker"], pinData, pinData[1], pinData[2])
	end
end
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
--when game loads -> adds pins, creates menu
function Mers.OnLoad(event, name)
   	if name ~= "Merchants" then return end

	Mers.SavedVariables = ZO_SavedVars:New("Mers_SavedVariables", 1, nil, Mers.defaults)

	Mers.MapPins = CustomMapPins:New() 
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--Condition placing Icons OnLoad only if Saved Variable is True (UIRELOAD FIX)

    --Alchemist
	if Mers.SavedVariables.showAlchemist == false then
	         Mers.MapPins:enablePins( "MersMapPin_Alchemist", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Alchemist", Mers.pinLayout_Alchemist, Mers.pinTooltipCreator, Mers.pinCreator_Alchemist)
	end

	--Armorer
	if Mers.SavedVariables.showArmorer == false then
	         Mers.MapPins:enablePins( "MersMapPin_Armorer", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Armorer", Mers.pinLayout_Armorer, Mers.pinTooltipCreator, Mers.pinCreator_Armorer)
	end
	
	--Armsman
	if Mers.SavedVariables.showArmsman == false then
	         Mers.MapPins:enablePins( "MersMapPin_Armsman", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Armsman", Mers.pinLayout_Armsman, Mers.pinTooltipCreator, Mers.pinCreator_Armsman)
	end
	
	--Banker
	if Mers.SavedVariables.showBanker == false then
	         Mers.MapPins:enablePins( "MersMapPin_Banker", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Banker", Mers.pinLayout_Banker, Mers.pinTooltipCreator, Mers.pinCreator_Banker)
	end
	
	--Blacksmith
	if Mers.SavedVariables.showBlacksmith == false then
	         Mers.MapPins:enablePins( "MersMapPin_Blacksmith", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Blacksmith", Mers.pinLayout_Blacksmith, Mers.pinTooltipCreator, Mers.pinCreator_Blacksmith)
	end
	
	--Brewer
	if Mers.SavedVariables.showBrewer == false then
	         Mers.MapPins:enablePins( "MersMapPin_Brewer", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Brewer", Mers.pinLayout_Brewer, Mers.pinTooltipCreator, Mers.pinCreator_Brewer)
	end
	
	--Carpenter
	if Mers.SavedVariables.showCarpenter == false then
	         Mers.MapPins:enablePins( "MersMapPin_Carpenter", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Carpenter", Mers.pinLayout_Carpenter, Mers.pinTooltipCreator, Mers.pinCreator_Carpenter)
	end
	
	--Chef
	if Mers.SavedVariables.showChef == false then
	         Mers.MapPins:enablePins( "MersMapPin_Chef", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Chef", Mers.pinLayout_Chef, Mers.pinTooltipCreator, Mers.pinCreator_Chef)
	end
	
	--Clothier
	if Mers.SavedVariables.showClothier == false then
	         Mers.MapPins:enablePins( "MersMapPin_Clothier", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Clothier", Mers.pinLayout_Clothier, Mers.pinTooltipCreator, Mers.pinCreator_Clothier)
	end
	
	--Grocer
	if Mers.SavedVariables.showGrocer == false then
	         Mers.MapPins:enablePins( "MersMapPin_Grocer", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Grocer", Mers.pinLayout_Grocer, Mers.pinTooltipCreator, Mers.pinCreator_Grocer)
	end
	
	--Enchanter
	if Mers.SavedVariables.showEnchanter == false then
	         Mers.MapPins:enablePins( "MersMapPin_Enchanter", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Enchanter", Mers.pinLayout_Enchanter, Mers.pinTooltipCreator, Mers.pinCreator_Enchanter)
	end
	
	--InnKeeper
	if Mers.SavedVariables.showInnKeeper == false then
	         Mers.MapPins:enablePins( "MersMapPin_InnKeeper", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_InnKeeper", Mers.pinLayout_InnKeeper, Mers.pinTooltipCreator, Mers.pinCreator_InnKeeper)
	end
	
	--Leatherworker
	if Mers.SavedVariables.showLeatherworker == false then
	         Mers.MapPins:enablePins( "MersMapPin_Leatherworker", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Leatherworker", Mers.pinLayout_Leatherworker, Mers.pinTooltipCreator, Mers.pinCreator_Leatherworker)
	end
	
	--Magister
	if Mers.SavedVariables.showMagister == false then
	         Mers.MapPins:enablePins( "MersMapPin_Magister", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Magister", Mers.pinLayout_Magister, Mers.pinTooltipCreator, Mers.pinCreator_Magister)
	end
	
	--Magus
	if Mers.SavedVariables.showMagus == false then
	         Mers.MapPins:enablePins( "MersMapPin_Magus", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Magus", Mers.pinLayout_Magus, Mers.pinTooltipCreator, Mers.pinCreator_Magus)
	end
	
	--Merchant
	if Mers.SavedVariables.showMerchant == false then
	         Mers.MapPins:enablePins( "MersMapPin_Merchant", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Merchant", Mers.pinLayout_Merchant, Mers.pinTooltipCreator, Mers.pinCreator_Merchant)
	end
	
	--Mystic
	if Mers.SavedVariables.showMystic == false then
	         Mers.MapPins:enablePins( "MersMapPin_Mystic", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Mystic", Mers.pinLayout_Mystic, Mers.pinTooltipCreator, Mers.pinCreator_Mystic)
	end
	
	--Pack Merchant
	if Mers.SavedVariables.showPackMerchant == false then
	         Mers.MapPins:enablePins( "MersMapPin_PackMerchant", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_PackMerchant", Mers.pinLayout_PackMerchant, Mers.pinTooltipCreator, Mers.pinCreator_PackMerchant)
	end
	
    --Stablemaster
	if Mers.SavedVariables.showStablemaster == false then
	         Mers.MapPins:enablePins( "MersMapPin_Stablemaster", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Stablemaster", Mers.pinLayout_Stablemaster, Mers.pinTooltipCreator, Mers.pinCreator_Stablemaster)
	end
	
	--Tailor
	if Mers.SavedVariables.showTailor == false then
	         Mers.MapPins:enablePins( "MersMapPin_Tailor", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Tailor", Mers.pinLayout_Tailor, Mers.pinTooltipCreator, Mers.pinCreator_Tailor)
	end
	
	--Weaponsmith
	if Mers.SavedVariables.showWeaponsmith == false then
	         Mers.MapPins:enablePins( "MersMapPin_Weaponsmith", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Weaponsmith", Mers.pinLayout_Weaponsmith, Mers.pinTooltipCreator, Mers.pinCreator_Weaponsmith)
			 
	end
	
	--Woodworker
	if Mers.SavedVariables.showWoodworker == false then
	         Mers.MapPins:enablePins( "MersMapPin_Woodworker", disable )
	else
		     Mers.MapPins:CreatePinType("MersMapPin_Woodworker", Mers.pinLayout_Woodworker, Mers.pinTooltipCreator, Mers.pinCreator_Woodworker)
			 
	end
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Mers.MapPins:RefreshPins()

	-- addon menu
	local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
	local addonMenu = LAM:CreateControlPanel("Merchants_OptionsPanel", "Merchants")
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	--Alchemist
	local function GetAlchemist()
		return Mers.SavedVariables.showAlchemist
	end

	local function SetAlchemist()
		if Mers.SavedVariables.showAlchemist == true then
	         Mers.SavedVariables.showAlchemist = not Mers.SavedVariables.showAlchemist
			 Mers.MapPins:enablePins( "MersMapPin_Alchemist", disable )
		else
		     Mers.SavedVariables.showAlchemist = not Mers.SavedVariables.showAlchemist
			 Mers.MapPins:CreatePinType("MersMapPin_Alchemist", Mers.pinLayout_Alchemist, Mers.pinTooltipCreator, Mers.pinCreator_Alchemist)
	    end
		Mers.MapPins:RefreshPins()
	end
		
	--ArmorSmith
	local function GetArmorsmith()
		return Mers.SavedVariables.showArmorsmith
	end

	local function SetArmorsmith()
		if Mers.SavedVariables.showArmorsmith == true then
	         Mers.SavedVariables.showArmorsmith = not Mers.SavedVariables.showArmorsmith
			 Mers.MapPins:enablePins( "MersMapPin_Armorsmith", disable )
		else
		     Mers.SavedVariables.showArmorsmith = not Mers.SavedVariables.showArmorsmith
			 Mers.MapPins:CreatePinType("MersMapPin_Armorsmith", Mers.pinLayout_Armorsmith, Mers.pinTooltipCreator, Mers.pinCreator_Armorsmith)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Armsman
	local function GetArmsman()
		return Mers.SavedVariables.showArmsman
	end

	local function SetArmsman()
		if Mers.SavedVariables.showArmsman == true then
	         Mers.SavedVariables.showArmsman = not Mers.SavedVariables.showArmsman
			 Mers.MapPins:enablePins( "MersMapPin_Armsman", disable )
		else
		     Mers.SavedVariables.showArmsman = not Mers.SavedVariables.showArmsman
			 Mers.MapPins:CreatePinType("MersMapPin_Armsman", Mers.pinLayout_Armsman, Mers.pinTooltipCreator, Mers.pinCreator_Armsman)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Banker
	local function GetBanker()
		return Mers.SavedVariables.showBanker
	end

	local function SetBanker()	
		if Mers.SavedVariables.showBanker == true then
	         Mers.SavedVariables.showBanker = not Mers.SavedVariables.showBanker
			 Mers.MapPins:enablePins( "MersMapPin_Banker", disable )
		else
		     Mers.SavedVariables.showBanker = not Mers.SavedVariables.showBanker
			 Mers.MapPins:CreatePinType("MersMapPin_Banker", Mers.pinLayout_Banker, Mers.pinTooltipCreator, Mers.pinCreator_Banker)
	    end
		Mers.MapPins:RefreshPins()
	end
		
	--BlackSmith
	local function GetBlacksmith()
		return Mers.SavedVariables.showBlacksmith
	end

	local function SetBlacksmith()	
		if Mers.SavedVariables.showBlacksmith == true then
	         Mers.SavedVariables.showBlacksmith = not Mers.SavedVariables.showBlacksmith
			 Mers.MapPins:enablePins( "MersMapPin_Blacksmith", disable )
		else
		     Mers.SavedVariables.showBlacksmith = not Mers.SavedVariables.showBlacksmith
			 Mers.MapPins:CreatePinType("MersMapPin_Blacksmith", Mers.pinLayout_Blacksmith, Mers.pinTooltipCreator, Mers.pinCreator_Blacksmith)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Brewer
	local function GetBrewer()
		return Mers.SavedVariables.showBrewer
	end

	local function SetBrewer()	
		if Mers.SavedVariables.showBrewer == true then
	         Mers.SavedVariables.showBrewer = not Mers.SavedVariables.showBrewer
			 Mers.MapPins:enablePins( "MersMapPin_Brewer", disable )
		else
		     Mers.SavedVariables.showBrewer = not Mers.SavedVariables.showBrewer
			 Mers.MapPins:CreatePinType("MersMapPin_Brewer", Mers.pinLayout_Brewer, Mers.pinTooltipCreator, Mers.pinCreator_Brewer)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Carpenter
	local function GetCarpenter()
		return Mers.SavedVariables.showCarpenter
	end

	local function SetCarpenter()	
		if Mers.SavedVariables.showCarpenter == true then
	         Mers.SavedVariables.showCarpenter = not Mers.SavedVariables.showCarpenter
			 Mers.MapPins:enablePins( "MersMapPin_Carpenter", disable )
		else
		     Mers.SavedVariables.showCarpenter = not Mers.SavedVariables.showCarpenter
			 Mers.MapPins:CreatePinType("MersMapPin_Carpenter", Mers.pinLayout_Carpenter, Mers.pinTooltipCreator, Mers.pinCreator_Carpenter)
	    end
		Mers.MapPins:RefreshPins()
	end

	--Chef
	local function GetChef()
		return Mers.SavedVariables.showChef
	end

	local function SetChef()	
		if Mers.SavedVariables.showChef == true then
	         Mers.SavedVariables.showChef = not Mers.SavedVariables.showChef
			 Mers.MapPins:enablePins( "MersMapPin_Chef", disable )
		else
		     Mers.SavedVariables.showChef = not Mers.SavedVariables.showChef
			 Mers.MapPins:CreatePinType("MersMapPin_Chef", Mers.pinLayout_Chef, Mers.pinTooltipCreator, Mers.pinCreator_Chef)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Clothier
	local function GetClothier()
		return Mers.SavedVariables.showClothier
	end

	local function SetClothier()
		if Mers.SavedVariables.showClothier == true then
	         Mers.SavedVariables.showClothier = not Mers.SavedVariables.showClothier
			 Mers.MapPins:enablePins( "MersMapPin_Clothier", disable )
		else
		     Mers.SavedVariables.showClothier = not Mers.SavedVariables.showClothier
			 Mers.MapPins:CreatePinType("MersMapPin_Clothier", Mers.pinLayout_Clothier, Mers.pinTooltipCreator, Mers.pinCreator_Clothier)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Enchanter
	local function GetEnchanter()
		return Mers.SavedVariables.showEnchanter
	end

	local function SetEnchanter()
		if Mers.SavedVariables.showEnchanter == true then
	         Mers.SavedVariables.showEnchanter = not Mers.SavedVariables.showEnchanter
			 Mers.MapPins:enablePins( "MersMapPin_Enchanter", disable )
		else
		     Mers.SavedVariables.showEnchanter = not Mers.SavedVariables.showEnchanter
			 Mers.MapPins:CreatePinType("MersMapPin_Enchanter", Mers.pinLayout_Enchanter, Mers.pinTooltipCreator, Mers.pinCreator_Enchanter)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Grocer
	local function GetGrocer()
		return Mers.SavedVariables.showGrocer
	end

	local function SetGrocer()
		if Mers.SavedVariables.showGrocer == true then
	         Mers.SavedVariables.showGrocer = not Mers.SavedVariables.showGrocer
			 Mers.MapPins:enablePins( "MersMapPin_Grocer", disable )
		else
		     Mers.SavedVariables.showGrocer = not Mers.SavedVariables.showGrocer
			 Mers.MapPins:CreatePinType("MersMapPin_Grocer", Mers.pinLayout_Grocer, Mers.pinTooltipCreator, Mers.pinCreator_Grocer)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--InnKeeper
	local function GetInnKeeper()
		return Mers.SavedVariables.showInnKeeper
	end

	local function SetInnKeeper()
		if Mers.SavedVariables.showInnKeeper == true then
	         Mers.SavedVariables.showInnKeeper = not Mers.SavedVariables.showInnKeeper
			 Mers.MapPins:enablePins( "MersMapPin_InnKeeper", disable )
		else
		     Mers.SavedVariables.showInnKeeper = not Mers.SavedVariables.showInnKeeper
			 Mers.MapPins:CreatePinType("MersMapPin_InnKeeper", Mers.pinLayout_InnKeeper, Mers.pinTooltipCreator, Mers.pinCreator_InnKeeper)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--LeatherWorker
	local function GetLeatherworker()
		return Mers.SavedVariables.showLeatherworker
	end

	local function SetLeatherworker()
		if Mers.SavedVariables.showLeatherworker == true then
	         Mers.SavedVariables.showLeatherworker = not Mers.SavedVariables.showLeatherworker
			 Mers.MapPins:enablePins( "MersMapPin_Leatherworker", disable )
		else
		     Mers.SavedVariables.showLeatherworker = not Mers.SavedVariables.showLeatherworker
			 Mers.MapPins:CreatePinType("MersMapPin_Leatherworker", Mers.pinLayout_Leatherworker, Mers.pinTooltipCreator, Mers.pinCreator_Leatherworker)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Magister
	local function GetMagister()
		return Mers.SavedVariables.showMagister
	end

	local function SetMagister()
		if Mers.SavedVariables.showMagister == true then
	         Mers.SavedVariables.showMagister = not Mers.SavedVariables.showMagister
			 Mers.MapPins:enablePins( "MersMapPin_Magister", disable )
		else
		     Mers.SavedVariables.showMagister = not Mers.SavedVariables.showMagister
			 Mers.MapPins:CreatePinType("MersMapPin_Magister", Mers.pinLayout_Magister, Mers.pinTooltipCreator, Mers.pinCreator_Magister)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Magus
	local function GetMagus()
		return Mers.SavedVariables.showMagus
	end

	local function SetMagus()
		if Mers.SavedVariables.showMagus == true then
	         Mers.SavedVariables.showMagus = not Mers.SavedVariables.showMagus
			 Mers.MapPins:enablePins( "MersMapPin_Magus", disable )
		else
		     Mers.SavedVariables.showMagus = not Mers.SavedVariables.showMagus
			 Mers.MapPins:CreatePinType("MersMapPin_Magus", Mers.pinLayout_Magus, Mers.pinTooltipCreator, Mers.pinCreator_Magus)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Merchant
	local function GetMerchant()
		return Mers.SavedVariables.showMerchant
	end

	local function SetMerchant()
		if Mers.SavedVariables.showMerchant == true then
	         Mers.SavedVariables.showMerchant = not Mers.SavedVariables.showMerchant
			 Mers.MapPins:enablePins( "MersMapPin_Merchant", disable )
		else
		     Mers.SavedVariables.showMerchant = not Mers.SavedVariables.showMerchant
			 Mers.MapPins:CreatePinType("MersMapPin_Merchant", Mers.pinLayout_Merchant, Mers.pinTooltipCreator, Mers.pinCreator_Merchant)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Mystic
	local function GetMystic()
		return Mers.SavedVariables.showMystic
	end

	local function SetMystic()
		if Mers.SavedVariables.showMystic == true then
	         Mers.SavedVariables.showMystic = not Mers.SavedVariables.showMystic
			 Mers.MapPins:enablePins( "MersMapPin_Mystic", disable )
		else
		     Mers.SavedVariables.showMystic = not Mers.SavedVariables.showMystic
			 Mers.MapPins:CreatePinType("MersMapPin_Mystic", Mers.pinLayout_Mystic, Mers.pinTooltipCreator, Mers.pinCreator_Mystic)
	    end
		Mers.MapPins:RefreshPins()
	end

	--Pack Merchant
	local function GetPackMerchant()
	    return Mers.SavedVariables.showPackMerchant
	end
	
	local function SetPackMerchant()
	    if Mers.SavedVariables.showPackMerchant == true then
	         Mers.SavedVariables.showPackMerchant = not Mers.SavedVariables.showPackMerchant
			 Mers.MapPins:enablePins( "MersMapPin_PackMerchant", disable )
		else
		     Mers.SavedVariables.showPackMerchant = not Mers.SavedVariables.showPackMerchant
			 Mers.MapPins:CreatePinType("MersMapPin_PackMerchant", Mers.pinLayout_PackMerchant, Mers.pinTooltipCreator, Mers.pinCreator_PackMerchant)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Stablemaster
	local function GetStablemaster()
		return Mers.SavedVariables.showStablemaster
	end

	local function SetStablemaster()
		if Mers.SavedVariables.showStablemaster == true then
	         Mers.SavedVariables.showStablemaster = not Mers.SavedVariables.showStablemaster
			 Mers.MapPins:enablePins( "MersMapPin_Stablemaster", disable )
		else
		     Mers.SavedVariables.showStablemaster = not Mers.SavedVariables.showStablemaster
			 Mers.MapPins:CreatePinType("MersMapPin_Stablemaster", Mers.pinLayout_Stablemaster, Mers.pinTooltipCreator, Mers.pinCreator_Stablemaster)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--Tailor
	local function GetTailor()
		return Mers.SavedVariables.showTailor
	end

	local function SetTailor()
		if Mers.SavedVariables.showTailor == true then
	         Mers.SavedVariables.showTailor = not Mers.SavedVariables.showTailor
			 Mers.MapPins:enablePins( "MersMapPin_Tailor", disable )
		else
		     Mers.SavedVariables.showTailor = not Mers.SavedVariables.showTailor
			 Mers.MapPins:CreatePinType("MersMapPin_Tailor", Mers.pinLayout_Tailor, Mers.pinTooltipCreator, Mers.pinCreator_Tailor)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--WeaponSmith
	local function GetWeaponsmith()
		return Mers.SavedVariables.showWeaponsmith
	end

	local function SetWeaponsmith()
		if Mers.SavedVariables.showWeaponsmith == true then
	         Mers.SavedVariables.showWeaponsmith = not Mers.SavedVariables.showWeaponsmith
			 Mers.MapPins:enablePins( "MersMapPin_Weaponsmith", disable )
		else
		     Mers.SavedVariables.showWeaponsmith = not Mers.SavedVariables.showWeaponsmith
			 Mers.MapPins:CreatePinType("MersMapPin_Weaponsmith", Mers.pinLayout_Weaponsmith, Mers.pinTooltipCreator, Mers.pinCreator_Weaponsmith)
	    end
		Mers.MapPins:RefreshPins()
	end
	
	--WoodWorker
	local function GetWoodworker()
		return Mers.SavedVariables.showWoodworker
	end

	local function SetWoodworker()
		if Mers.SavedVariables.showWoodworker == true then
	         Mers.SavedVariables.showWoodworker = not Mers.SavedVariables.showWoodworker
			 Mers.MapPins:enablePins( "MersMapPin_Woodworker", disable )
		else
		     Mers.SavedVariables.showWoodworker = not Mers.SavedVariables.showWoodworker
			 Mers.MapPins:CreatePinType("MersMapPin_Woodworker", Mers.pinLayout_Woodworker, Mers.pinTooltipCreator, Mers.pinCreator_Woodworker)
	    end
		Mers.MapPins:RefreshPins()
	end
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	--Merchant
	--local function GetSizeMerchant()
	    -- d("Got size : " .. Mers.SavedVariables.sizeMerchant )
		-- return Mers.SavedVariables.sizeMerchant
	--end

	--local function SetSizeMerchant(newScale)
	    -- Mers.SavedVariables.sizeMerchant = newScale
		-- Mers.MapPins:RefreshPins()
		 -- d("Set size : " .. Mers.SavedVariables.sizeMerchant)
	--end
	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	LAM:AddHeader(addonMenu, "Merchants_OptionsHeader", "MapMarker Options")
		LAM:AddHeader(addonMenu, "Merchants_OptionsHeader1", "Display")
	LAM:AddCheckbox(addonMenu, "Merchants_showAlchemist", "Show Alchemists", "Show/hide Alchemists.", GetAlchemist, SetAlchemist)
	LAM:AddCheckbox(addonMenu, "Merchants_showArmorer", "Show Armorers", "Show/hide Armorers.", GetArmorsmith, SetArmorsmith)
	LAM:AddCheckbox(addonMenu, "Merchants_showArmsman", "Show Armsmen", "Show/hide Armsmen.", GetArmsman, SetArmsman)
	LAM:AddCheckbox(addonMenu, "Merchants_showBanker", "Show Bankers", "Show/hide Bankers.", GetBanker, SetBanker)
	LAM:AddCheckbox(addonMenu, "Merchants_showBlacksmith", "Show Blacksmiths", "Show/hide Blacksmiths.", GetBlacksmith, SetBlacksmith)
	LAM:AddCheckbox(addonMenu, "Merchants_showBrewer", "Show Brewers", "Show/hide Brewers.", GetBrewer, SetBrewer)
	LAM:AddCheckbox(addonMenu, "Merchants_showCarpenter", "Show Carpenters", "Show/hide Carpenters.", GetCarpenter, SetCarpenter)
	LAM:AddCheckbox(addonMenu, "Merchants_showChef", "Show Chefs", "Show/hide Chefs.", GetChef, SetChef)
	LAM:AddCheckbox(addonMenu, "Merchants_showClothier", "Show Clothiers", "Show/hide Clothiers.", GetClothier, SetClothier)
	LAM:AddCheckbox(addonMenu, "Merchants_showEnchanter", "Show Enchanters", "Show/hide Enchanters.", GetEnchanter, SetEnchanter)
	LAM:AddCheckbox(addonMenu, "Merchants_showGrocer", "Show Grocers", "Show/hide Grocers.", GetGrocer, SetGrocer)
	LAM:AddCheckbox(addonMenu, "Merchants_showInnKeeper", "Show InnKeepers", "Show/hide InnKeepers.", GetInnKeeper, SetInnKeeper)
	LAM:AddCheckbox(addonMenu, "Merchants_showLeatherworker", "Show Leatherworkers", "Show/hide Leatherworkers.", GetLeatherworker, SetLeatherworker)
	LAM:AddCheckbox(addonMenu, "Merchants_showMagister", "Show Magisters", "Show/hide Magisters.", GetMagister, SetMagister)
	LAM:AddCheckbox(addonMenu, "Merchants_showMagus", "Show Maguses", "Show/hide Maguses.", GetMagus, SetMagus)
	LAM:AddCheckbox(addonMenu, "Merchants_showMerchant", "Show Merchants", "Show/hide Merchants.", GetMerchant, SetMerchant)
	LAM:AddCheckbox(addonMenu, "Merchants_showMystic", "Show Mystics", "Show/hide Mystics.", GetMystic, SetMystic)
	LAM:AddCheckbox(addonMenu, "Merchants_showPackMerchant", "Show BackPack Merchants", "Show/hide BackPack Merchants.", GetPackMerchant, SetPackMerchant)
	LAM:AddCheckbox(addonMenu, "Merchants_showStablemaster", "Show Stablemasters", "Show/hide Stablemasters.", GetStablemaster, SetStablemaster)
	LAM:AddCheckbox(addonMenu, "Merchants_showTailor", "Show Tailors", "Show/hide Tailors.", GetTailor, SetTailor)
	LAM:AddCheckbox(addonMenu, "Merchants_showWeaponsmith", "Show Weapon Smiths", "Show/hide Weapon Smiths.", GetWeaponsmith, SetWeaponsmith)
	LAM:AddCheckbox(addonMenu, "Merchants_showWoodworker", "Show Woodworkers", "Show/hide Woodworkers.", GetWoodworker, SetWoodworker)
		--LAM:AddHeader(addonMenu, "Merchants_OptionsHeader2", "Size")
	--LAM:AddSlider(addonMenu,"Merchants_SizeMerchant","Size Merchant Pins","Change the size for Merchant pins.",	0, 100, 1, GetSizeMerchant, SetSizeMerchant)	
		--LAM:AddHeader(addonMenu, "Merchants_OptionsHeader3", "Color")
	
		
		
	EVENT_MANAGER:UnregisterForEvent("Merchants", EVENT_ADD_ON_LOADED)
end

EVENT_MANAGER:RegisterForEvent("Merchants_OnLoad", EVENT_ADD_ON_LOADED, Mers.OnLoad)
