local Author = "Created By SkOODaT & Mitsarugi" 
local Version = "Version 100003.4"

local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")

local NPCReticleScan = {}
local NPCDetectRange = 1    --- How Far Away To Detect The NPC 15 Is Just A Bit Beyond Melee Range

Default = {
    data = {}
}

--NPC Types According To Merchants Addon
NPCType = { 
["Alchemist"] = "21",
["Armorer"] = "22",
["Blacksmith"] = "23",
["Clothier"] = "24",
["Grocer"] = "25",
["Leatherworker"] = "26",
["Merchant"] = "27",
["Mystic"] = "28",
["Pack Merchant"] = "29",
["Tailor"] = "30",
["Weaponsmith"] = "31",
["Woodworker"] = "32",
["Chef"] = "33",
["Brewer"] = "34",
["Enchanter"] = "35",
["Innkeeper"] = "36",
["Magus"] = "37",
["Banker"] = "38",
["Carpenter"] = "39",
["Armsman"] = "40",
["Stablemaster"] = "41",
["Magister"] = "42",

}
function NPCRSSavedVariables()
    NPCRSSaved = {
        ["npc"] = ZO_SavedVars:NewAccountWide("NPCReticleScanSavedVars", 1, "npc", Default),
    }
end

	
function TargetChanged(Event, Unit)
    local x, y, z = GetMapPlayerPosition("player")     -- Get Player Position
    local Name = GetUnitName("reticleover")             -- Get The Reticle Target
    local Caption = GetUnitCaption("reticleover")       -- Get Unit Caption "BlackSmith" "Bank"
    local Reaction = GetUnitReaction('reticleover')     -- Get Unit Reaction For Checking Purposes 3 == NPC
    local Subzone = GetMapName()  
    local Extra1 = "Inside Building"
    local ExtraInfoInsideBuilding = false	
	local Blank = (Name == "" or Name == " ")      -- Ignore Blank Targets
    if not IsCritter(Name) and not Blank then          -- Check For Critters
        if DoesUnitExist('reticleover') then        -- Make Sure Thier Is A Target
            if not IsUnitPlayer('reticleover') then -- Make Sure Unit Isnt A Player
                if Reaction == 5 or Reaction == 7 then  -- Get Unit Reaction For Checking Purposes 5 == NPC
                    if Caption == nil then return end
                    if Caption then
                        local Type = NPCType[Caption]
                        if Type == nil then d(Caption .. " Needs To Be Added To The NPCTypes Database For Merchants Addon") return end
                        for i = 1, #NPCRSSaved["npc"].data do
                                local item = NPCRSSaved["npc"].data[i]
                                if item[2] == (Name) then
                                   -- d("Found NPC " ..Name.. " " ..Caption.. " Of " ..Subzone.. " In The Saved Var File NOT ADDING")
                                    return 
                                end
                        end
                        local targetName = GetUnitName('reticleover')
                        local targetX, targetY, targetH = GetMapPlayerPosition('reticleover')
                        local targetInNPCRange = false
                        local distance = -999
                        local selfX, selfY, selfH = GetMapPlayerPosition('player')
                        local mapWidth, mapHeight = GetMapNumTiles()
                        local mapType = GetMapType()
                        local mapContentType = GetMapContentType()
                        if targetX and targetY and targetName and string.len(targetName) > 0 then
                            local divisor = mapType * mapWidth
                                --local divisor = -1
                            if mapContentType == MAP_CONTENT_NONE then
                            if mapType == MAPTYPE_SUBZONE then
                                divisor = 15
                            elseif mapType == MAPTYPE_ZONE then
                                divisor = 2.5
                            end
                            elseif mapContentType == MAP_CONTENT_AVA then
                            if mapType == MAPTYPE_SUBZONE then
                                divisor = 25
                            elseif mapType == MAPTYPE_ZONE then
                                divisor = 1.0
                            end
                            elseif mapContentType == MAP_CONTENT_DUNGEON then
                                if mapType == MAPTYPE_SUBZONE then
                                divisor = 21
                                elseif mapType == MAPTYPE_ZONE then
                                divisor = 26
                                end
                            end
                            local dist = math.sqrt(math.pow(((selfX / divisor) - (targetX / divisor)), 2) + math.pow(((selfY / divisor) - (targetY / divisor)), 2))
                            distance = math.floor((dist * 10000) - 0.5)
                            if distance <= NPCDetectRange then
                                targetInNPCRange = true	
                            end
                        end
                        if targetInNPCRange == true then
                            d("Added " .. Caption .. " " .. Name .. " in " .. Subzone .. " at " .. Round(x)*100 .. ";" .. Round(y)*100 .. " to the Database!")
                            --Log("npc", Round(x) .. ', ' .. Round(y) .. ', ' .. Round(z) .. ', "' .. Name .. '", ' .. Type, Name, Caption, Subzone)
							if ExtraInfoInsideBuilding == false then
                                Log("npc", Round(x) .. ', ' .. Round(y) .. ', "' .. Name .. '", ' .. Type, Name, Caption, Subzone)
							else 
							    Log("npc", Round(x) .. ', ' .. Round(y) .. ', "' .. Name .. '", ' .. Type, Name, Caption, Subzone, Extra1)
							end
                        end                        
                    end
                end
            end
        end
    end
end


local function ExtraInfo1()
     d("ExtraInfo = " ..ExtraInfoInsideBuilding)
end

-- Round To 2 Decimals WAY Easier
function Round(num, idp)
  return tonumber(string.format("%." .. (idp or 2) .. "f", num))
end

-- Logs Saved Variables To File
function Log(type, ...)
    local data = {}
    local dataStr = ""
    local sv
    if NPCRSSaved[type] == nil or NPCRSSaved[type].data == nil then
        d("Attempted to log unknown type to the database: " .. type)
        return
    else
        sv = NPCRSSaved[type].data
    end
    for i = 1, select("#", ...) do
        local value = select(i, ...)
        data[i] = value
        dataStr = dataStr .. tostring(value)
    end
    --d("Logged [" .. type .. "] data: " .. dataStr)
    if #sv == 0 then
        sv[1] = data
    else
        sv[#sv+1] = data
    end
end

-- Borrowed Critter Check THIS IS NOT COPYRIGHTED
function IsCritter(Name)   -- Function To Check If Critter
	if (GetUnitLevel("reticleover") ~= 1) then return false end -- Critters Are Always Level 1
	local Critters = {  -- The List Of Critters
		"Butterfly", "Lizard", "Rat", "Snake", "Pony Guar", "Frog", "Squirrel", "Rabbit", "Deer", "Cat", "Pig", "Sheep", "Antelope", "Wasp", "Monkey", "Fleshflies", "Centipede", "Chicken", "Torchbug", "Spider", "Scorpion", "Goat", "Scrib", "Scuttler",
	}
	for I = 1, #Critters do   -- Is The Target A Critter?
		if (Name == Critters[I]) then return true end
	end
	return false   -- Otherwise False
end

function OnAddonLoaded(Event, AddonName)
    if AddonName == "NPCReticleScan" then
     NPCRSSavedVariables()
     NPCRSCreateSettings()
    end
	-- slash commands
	SLASH_COMMANDS["/npcscanei"] = ExtraInfo1
end

function NPCRSCreateSettings()
    local Panel = LAM:CreateControlPanel("_NPCReticleScan", "NPC Reticle Scan")     -- Panel
    LAM:AddHeader(Panel, "NPCReticleScan_General", "General")               -- Panel Title
    LAM:AddDescription(Panel, "NPCReticleScan_Text1.1", "Automatically Scans for NPCs selling items")
    LAM:AddDescription(Panel, "NPCReticleScan_Text1.2", "generating a file that will help create a Database ")
	LAM:AddDescription(Panel, "NPCReticleScan_Text1.3", "for the addon Merchants.")
	LAM:AddDescription(Panel, "NPCReticleScan_Text1.4", "------------------")
	LAM:AddDescription(Panel, "NPCReticleScan_Text1.5", "Please share the generated file in the comment section on ESOUI.")
	LAM:AddDescription(Panel, "NPCReticleScan_Text1.6", "('NPCReticleScan.lua' in the SavedVariables folder)")
	LAM:AddDescription(Panel, "NPCReticleScan_Text2", "------------------")
    LAM:AddDescription(Panel, "NPCReticleScan_Text3", Author)
    LAM:AddDescription(Panel, "NPCReticleScan_Text4", Version)
end

EVENT_MANAGER:RegisterForEvent("NPCReticleScan", EVENT_ADD_ON_LOADED, OnAddonLoaded)
EVENT_MANAGER:RegisterForEvent("NPCReticleScan", EVENT_RETICLE_TARGET_CHANGED, TargetChanged)