if Mers == nil then Mers = {} end

-- MerchantsData format: locX, locY, NPCName, NPCType, [moreInfo]
--		moreInfo:
--			nil = default
--			1 = on city map
--			2 = in solo dungeon
--			3 = in public dungeon
--			4 = in cave 

Mers.BrewerData = { 
----Alik'r Desert (Daggerfall, lvl 31-37)
	["Alik'r Desert"] = {		--30
		
	},
	["Sentinel"] = {				--83
		
	},
	["Bergama"] = {				--539
		
	},
	["Kozanset"] = {				--538
		
	},
	["Aldunz"] = {					--231              
		
	},
	["Coldrock Diggings"] = {	--224
		
	},
	["Divads Chagrin Mine"] = {	--226
		
	},
	["Sandblown Mine"] = {		--230
		
	},
	["Santaki"] = {				--246
		
	},
	["Yldzuun"] = {				--233
		
	},
	["Lost City of the Na-Totambu"] = {	--76
		
	},

----Auridon (Aldmeri lvl 5-15)
	["Auridon"] = {
		
	},
	["Vulkhel Guard"] = {		--243
		{0.4, 0.62, "Parmanir", 34},
	},
	["Skywatch"] = {				--545
		{0.31, 0.45, "Valtir", 34},
		{0.33, 0.37, "Celwen", 34},
	},
	["Bewan"] = {					--180
	
	},
	["Del's Claim"] = {			--178
	
	},
	["Entila's Folly"] = {		--186
		
	},
	["Mehrunes' Spite"] = {		--182
		
	},
	["Ondil"] = {					--179
		
	},
	["Wansalen"] = {				--181
		
	},
	["Toothmaul Gully"] = {		--268
		
	},

----Bal Foyen (Ebonheart lvl 1-5)
	["Bal Foyen"] = {				--75
		
	},
	["Dhalmora"] = {				--56
		 {0.55, 0.61, "Finds-Plants", 34},
	},

----Bangkorai (Daggerfall, lvl 37-43)
	["Bangkorai"] = {				--20
		
	},
	["Evermore"] = {				--84
		
	},
	["Crypt of the Exiles"] = { --212
		
	},
	["Klathzgar"] = {				--232
		
	},
	["Torog's Spite"] = {		--229
		
	},
	["Rubble Butte"] = {			--245
		
	},
	["Troll's Toothpick"] = {	--239
	
	},
	["Viridian Watch"] = {		--236
		
	},
	["Razaks Wheel"] = {		--71
		
	},

----Betnikh (Daggerfall, lvl 1-5)
	["Betnikh"] = {				--227
	
	},

----Bleakrock Isle (Ebonheart, lvl 1-5)
	["Bleakrock Isle"] = {		--74
		
	},
	["Hozzin's Folly"] = {		--88
		
	},
	
----Coldharbour (all)
	["Coldharbour"] = {			--255
		
	},
	["Aba-Loria"] = {					--266
	
	},
	["The Vault of Haman Forgefire"] = {	--352
		
	},
	["The Grotto of Depravity"] = {	--261
		
	},
	["Mal Sorras Tomb"] = {		--332
		
	},
	["The Cave of Trophies"] = {	--594 
		
	},
	["The Wailing Maw"] = {			--263
		
	},
	["Village of the Lost"] = {	--339
		
	},

----Cyrodiil (all, lvl 10+)
	["Cyrodiil"] = {					--16
	--Aldmeri
		
	--Daggerfall
		
	--Ebonheart
		
	--Mountain
		
	},
	--Aldmeri
	["Bloodmayne Cave"] = {			--469
		
	},
	["Breakneck Cave"] = {			--285
		
	},
	["Haynote Cave"] = {				--286
		
	},
	["Nisin Cave"] = {				--467
		
	},
	["Pothole Caverns"] = {			--291
		
	},
	["Serpent Hollow Cave"] = {	--466
	
	},
	--Dagerrfall
	["Capstone Cave"] = {			--470
		
	},
	["Echo Cave"] = {					--473
		
	},
	["Lipsand Tarn"] = {				--290
		
	},
	["Red Ruby Cave"] = {			--289
		
	},
	["Toadstool Hollow"] = {		--294 
		
	},
	["Underpall Cave"] = {			--288
		
	},
	--Ebonheart
	["Cracked Wood Cave"] = {		--474
		
	},
	["Kingscrest Cavern"] = {		--340
	
	},
	["Muck Valley Cavern"] = {		--287
		
	},
	["Newt Cave"] = {					--468
		
	},
	["Quickwater Cave"] = {			--471
		
	},
	["Vahtacen"] = {					--299
		
	},

----Deshaan (Ebonheart, lvl 16-23)
    ["Deshaan"] = {					--13
		{0.78, 0.48, "In-No-Hurry", 34},
		{0.78, 0.48, "Daleez", 34},
    },
	["Narsis"] = {						--537
		{0.45, 0.65, "Nibar", 34},
	},
	["Mournhold"] = {					--205
		{0.72, 0.65, "Guroanii Orethi", 34, 8, 9},
		{0.32, 0.52, "Dururo Hlan", 34},
	},
	["Forgotten Crypts"] = {		--115
		
	},
	["Knife Ear Grotto"] = {		--123
		
	},
	["Lady Llarel's Shelter"] = {	--119
		
	},
	["Lower Bthanual"] = {			--121
		
	},
	["The Triple Circle Mine"] = { --120
		
	},
	["Taleon's Crag"] = {			--122
		
	},
	["The Corpse Garden"] = {		--124
		
	},

----Eastmarch (Ebonheart, lvl 31-37)
	["Eastmarch"] = {					--61
		
	},
	["Fort Amol"] = {					--578
		
	},
	["The Bastard's Tomb"] = {		--167
		
	},
	["The Chill Hollow"] = {		--163
		
	},
	["The Frigid Grotto"] = {		--166
		
	},
	["Icehammer's Vault"] = {		--164
		
	},
	["Old Sords Cave"] = {			--165
		
	},
	["Stormcrag Crypt"] = {			--168
		
	},
	["Hall of the Dead"] = {		--140
		
	},

----Glenumbra (Daggerfall, lvl 5-15)
	["Glenumbra"] = {					--1
		
	},
	["Daggerfall"] = {				--63
		{0.5, 0.28, "Phelain Bertault", 34},
	},
	["Crosswych"] = {		--541
	
	},
	["Ilessan Tower"] = {			--237
		
	},
	["Silumm"] = {						--111
		
	},
	["Mines of Khuras"] = {			--228
		
	},
	["Enduum"] = {						--203
		
	},
	["Ebon Crypt"] = {				--215
		
	},
	["Cryptwatch Fort"] = {			--235
		
	},
	["Bad Man's Hallows"] = {		--65 (has more floors, mapIDs: 65,98,99)
		
	},

----Grahtwood (Aldmeri, lvl 16-23)
	["Grahtwood"] = {					--9
		
	},
	["Haven"] = {					--512
		
	},
	["Elden Root"] = {			--445
		
	},
	["Ne Salas"] = {				--404
	
	},
	["The Scuttle Pit"] = {		--394
		
	},
	["Burroot Kwama Mine"] = {	--396
		
	},
	["Vinedeath Cave"] = {		--393
		
	},
	["Wormroot Depths"] = {		--414
		
	},
	["Mobar Mine"] = {			--395
		
	},
	["Root Sunder Ruins"] = {	--283
		
	},

----Greenshade (Aldmeri lvl 25-30)
	["Greenshade"] = {			--300
		
	},
	["Marbruk"] = {				--387
		{0.5, 0.43, "Eldumoril", 34},
	},
	["Woodhearth"] = {				--529
		{0.43, 0.71, "Pulaya", 34},
	},
	["Gurzags Mine"] = {		--382
	
	},
	["Carac Dena"] = {			--386
		
	},
	["Naril Nagaia"] = {			--391
		
	},
	["The Underroot"] = {		--384
		
	},
	["Harridans Lair"] = {		--383
		
	},
	["Barrow Trench"] = {		--380
		
	},
	["Rulanyils Fall"] = {		--278
		
	},

----Khenarthi's Roost (Aldmeri, lvl 1-5)
	["Khenarthi's Roost"] = {	--258
		
	},
	["Mistral"] = {				--567
		{0.41, 0.35, "Huthak", 34},
	},

----Malabal Tor (Aldmeri, lvl 31-37)
	["Malabal Tor"] = {			--22
		
	},
	
	["Velyn Harbor"] = {
	    {0.29, 0.51, "Benieth", 34},
	},
	["Vulkwasten"] = {			--534
		{0.59, 0.57, "Walks-With-Spirits", 34},
	},
	["Black Vine Ruins"] = {	--199
		
	},
	["Dead Mans Drop"] = {		--222
		
	},
	["Hoarvor Pit"] = {			--262
		
	},
	["Roots of Silvenar"] = {	--267
		
	},
	["Shael Ruins"] = {			--260
		
	},
	["Tomb of the Apostates"] = { --221
		
	},
	["Crimson Cove"] = {			--175
		
	},
							
----Reaper's March (Aldmeri, lvl 37-43)
	["Reaper's March"] = {		--256
		
	},
	["Dune"] = {					--533
		{0.35, 0.22, "Moon-Draughts", 34},
		{0.15, 0.54, "Masrabal-dro", 34},
	},
	["Kuna's Delve"] = {			--343
		
	},
	["Thibauts Cairn"] = {		--323
	
	},
	["Weeping Wind Cave"] = {	--307
		
	},
	["Claw's Strike"] = {		--301
		
	},
	["Fardir's Folly"] = {		--210
		
	},
	["Jode's Light"] = {			--304
		
	},
	["The Vile Manse"] = {		--317  (this dungeon has more floors, mapIDs: 317,318)  
		
	},

----Rivenspire (Daggerfall, lvl 25-30)
	["Rivenspire"] = {			--10
		
	},
	["Stornhelm"] = {				--85
		
	},
	["Northpoint"] = {			--513
		
	},
	["Crestshade Mine"] = {		--225
		
	},
	["Erokii Ruins"] = {			--204
		
	},
	["Flyleaf Catacombs"] = {	--216
		
	},
	["Hildune's Secret Refuge"] = { --244
		
	},
	["Orc's Finger Ruins"] = {	--200
		
	},
	["Tribulation Crypt "] = {	--220
		
	},
	["Obsidian Scar"] = {		--42
		
	},
			
----Shadowfen (Ebonheart, lvl 25-30)
	["Shadowfen"] = {				--26
		{0.38, 0.73, "Anozz-Crath", 34},
	},
	["Stormhold"] = {				--217
		{0.36, 0.29, "Thastla", 34, 9},
		{0.35, 0.27, "Six-Coins", 34, 9},
	},
	["Alten Corimont"] = {		--544
		{0.4, 0.49, "Maalamenwe", 34},
		{0.47, 0.53, "Nerari", 34},
	},
	["Atanaz Ruins"] = {			--146
		
	},
	["Broken Tusk"] = {			--155
		
	},
	["Chid-Moska Ruins"] = {	--148
		
	},
	["Gandranen Ruins"] = {		--150
		
	},
	["Onkobra Kwama Mine"] = {	--147
		
	},
	["Shrine of the Black Maw"] = { --149
		
	},
	["Sanguine's Demesne"] = {
		{0.11, 0.54, "Graghesh", 34, 3},
	},

--Stonefalls (Ebonheart, lvl 5-15)
	["Stonefalls"] = {			--7
		
    },
	["Ebonheart"] = {
	    { 0.63, 0.57, "Darvynil Savel", 34, 9},
	},
	["Kragenmoor"] = {
	     { 0.44, 0.66, "Feduzdal", 34},
	},
	["Davon's Watch"] = {		--24
		 { 0.45, 0.51, "Nela Sethri", 34, 9},	
		 { 0.78, 0.49, "Hectur the Fish", 34},
	},
    ["Inner Sea Armature"] = {	--90
		
	},
	["Emberflint Mine"] = {		--112
		
	},
	["Mephala's Nest"] = {		--114
		
	},
	["Softloam Cavern"] = {		--110
		
	},
	["Hightide Hollows"] = {	--97
		
	},
	["Sheogorath's Tongue"] = { --113
		
	},
	["Crow's Wood"] = {			--72
		
	},

----Stormhaven (Daggerfall, lvl 16-23)
	["Stormhaven"] = {			--12
		
	},
	["Bearclaw Mine"] = {		--223
		
	},
	["Farangel's Delve"] = {	--249
		
	},
	["Koeglin Mine"] = {			--202
		
	},
	["Norvulk Ruins"] = {		--194
		
	},
	["Pariah Catacombs"] = {	--219
		
	},
	["Portdun Watch"] = {		--238
	
	},
	["Bonesnap Ruins"] = {		--189
		
	},

----Stros M'Kai (Daggerfall, lvl 1-5)
    ["Stros M'Kai"] = {			--201
		
	},
	["Port Hunding"] = {			--530
		
	},

----The Rift (Ebonheart, lvl 37-43)
	["The Rift"] = {				--125
	
	},
	["Shor's Stone"] = {			--542
		
	},
	["Avanchnzel"] = {			--169
		
	},
	["Faldar's Tooth"] = {		--214
		
	},
	["Fort Greenwall"] = {		--254
		
	},
	["Shroud Hearth Barrow"] = { --211
		
	},
	["Snapleg Cave"] = {			--265
		
	},
	["The Lion's Den"] = {		--142
		
	},
	["Nimalten"] = {		--142
		 {0.48, 0.54, "Aklief", 34, 9},
	},
	["Riften"] = {		--142
		 {0.52, 0.47, "Leaks-When-Struck", 34, 9},
	},
	["Baandari Trading Post"] = {
	    {0.54, 0.47, "Milaggul", 34},
	},
	["Firsthold"] = {
	    {0.74, 0.56, "Iduthal", 34},
	},
}