if Mers == nil then Mers = {} end

-- MerchantsData format: locX, locY, NPCName, NPCType, [moreInfo]
--		moreInfo:
--			nil = default
--			1 = on city map
--			2 = in solo dungeon
--			3 = in public dungeon
--			4 = in cave 

Mers.MerchantData = { 
----Alik'r Desert (Daggerfall, lvl 31-37)
	["Alik'r Desert"] = {		--30
		
	},
	["Sentinel"] = {				--83
		
	},
	["Bergama"] = {				--539
		
	},
	["Kozanset"] = {				--538
		
	},
	["Aldunz"] = {					--231              
		
	},
	["Coldrock Diggings"] = {	--224
		
	},
	["Divads Chagrin Mine"] = {	--226
		
	},
	["Sandblown Mine"] = {		--230
		
	},
	["Santaki"] = {				--246
		
	},
	["Yldzuun"] = {				--233
		
	},
	["Lost City of the Na-Totambu"] = {	--76
		
	},

----Auridon (Aldmeri lvl 5-15)
	["Auridon"] = {
		{0.25, 0.28, "Errataale", 27},
		{0.48, 0.22, "Mangitaale", 27},
	},
	["Vulkhel Guard"] = {		--243
		{0.24, 0.56, "Eshaba", 27},
		{0.31, 0.51, "Vesteldore", 27},
		{0.62, 0.46, "Zibam", 27},
	},
	["Skywatch"] = {				--545
		{0.35, 0.47, "Nilleth", 27},
		{},
	},
	["Bewan"] = {					--180
	
	},
	["Del's Claim"] = {			--178
	
	},
	["Entila's Folly"] = {		--186
		
	},
	["Mehrunes' Spite"] = {		--182
		
	},
	["Ondil"] = {					--179
		
	},
	["Wansalen"] = {				--181
		
	},
	["Toothmaul Gully"] = {		--268
		
	},

----Bal Foyen (Ebonheart lvl 1-5)
	["Bal Foyen"] = {				--75
		
	},
	["Dhalmora"] = {				--56
		 { 0.55, 0.48, "Fetches-Glitter", 27},
	},

----Bangkorai (Daggerfall, lvl 37-43)
	["Bangkorai"] = {				--20
		
	},
	["Evermore"] = {				--84
		
	},
	["Crypt of the Exiles"] = { --212
		
	},
	["Klathzgar"] = {				--232
		
	},
	["Torog's Spite"] = {		--229
		
	},
	["Rubble Butte"] = {			--245
		
	},
	["Troll's Toothpick"] = {	--239
	
	},
	["Viridian Watch"] = {		--236
		
	},
	["Razaks Wheel"] = {		--71
		
	},

----Betnikh (Daggerfall, lvl 1-5)
	["Betnikh"] = {				--227
	
	},

----Bleakrock Isle (Ebonheart, lvl 1-5)
	["Bleakrock Isle"] = {		--74
		
	},
	["Hozzin's Folly"] = {		--88
		
	},
	
----Coldharbour (all)
	["Coldharbour"] = {			--255
		
	},
	["Aba-Loria"] = {					--266
	
	},
	["The Vault of Haman Forgefire"] = {	--352
		
	},
	["The Grotto of Depravity"] = {	--261
		
	},
	["Mal Sorras Tomb"] = {		--332
		
	},
	["The Cave of Trophies"] = {	--594 
		
	},
	["The Wailing Maw"] = {			--263
		
	},
	["Village of the Lost"] = {	--339
		
	},

----Cyrodiil (all, lvl 10+)
	["Cyrodiil"] = {					--16
	--Aldmeri
		
	--Daggerfall
		
	--Ebonheart
		
	--Mountain
		
	},
	--Aldmeri
	["Bloodmayne Cave"] = {			--469
		
	},
	["Breakneck Cave"] = {			--285
		
	},
	["Haynote Cave"] = {				--286
		
	},
	["Nisin Cave"] = {				--467
		
	},
	["Pothole Caverns"] = {			--291
		
	},
	["Serpent Hollow Cave"] = {	--466
	
	},
	--Dagerrfall
	["Capstone Cave"] = {			--470
		
	},
	["Echo Cave"] = {					--473
		
	},
	["Lipsand Tarn"] = {				--290
		
	},
	["Red Ruby Cave"] = {			--289
		
	},
	["Toadstool Hollow"] = {		--294 
		
	},
	["Underpall Cave"] = {			--288
		
	},
	--Ebonheart
	["Cracked Wood Cave"] = {		--474
		
	},
	["Kingscrest Cavern"] = {		--340
	
	},
	["Muck Valley Cavern"] = {		--287
		
	},
	["Newt Cave"] = {					--468
		
	},
	["Quickwater Cave"] = {			--471
		
	},
	["Vahtacen"] = {					--299
		
	},

----Deshaan (Ebonheart, lvl 16-23)
    ["Deshaan"] = {					--13
		{ 0.47, 0.39, "Gidain Hlaalu", 27},
		{ 0.84, 0.40, "Dithisi Girvu", 27},
		{ 0.83, 0.53, "Trades-for-Gold", 27},
		{ 0.56, 0.39, "Alvon", 27},
		{0.58, 0.54, "Apprentice Ithrini", 27},
    },
	["Narsis"] = {						--537
		{ 0.44, 0.66, "Auda the Peddler", 27},
	},
	["Mournhold"] = {					--205
		{0.47, 0.64, "Gunar the Red", 27, 9},
		{0.48, 0.63, "Hops-Over-Fires", 27, 9},
		{0.32, 0.52, "Gelii Hlaalu", 27},
	},
	["Forgotten Crypts"] = {		--115
		
	},
	["Knife Ear Grotto"] = {		--123
		
	},
	["Lady Llarel's Shelter"] = {	--119
		
	},
	["Lower Bthanual"] = {			--121
		
	},
	["The Triple Circle Mine"] = { --120
		
	},
	["Taleon's Crag"] = {			--122
		
	},
	["The Corpse Garden"] = {		--124
		
	},

----Eastmarch (Ebonheart, lvl 31-37)
	["Eastmarch"] = {					--61
		
	},
	["Fort Amol"] = {					--578
		
	},
	["The Bastard's Tomb"] = {		--167
		
	},
	["The Chill Hollow"] = {		--163
		
	},
	["The Frigid Grotto"] = {		--166
		
	},
	["Icehammer's Vault"] = {		--164
		
	},
	["Old Sords Cave"] = {			--165
		
	},
	["Stormcrag Crypt"] = {			--168
		
	},
	["Hall of the Dead"] = {		--140
		
	},

----Glenumbra (Daggerfall, lvl 5-15)
	["Glenumbra"] = {					--1
		
	},
	["Daggerfall"] = {				--63
		{0.59, 0.44, "Daria Thenephan", 27},
	},
	["Crosswych"] = {		--541
	
	},
	["Ilessan Tower"] = {			--237
		
	},
	["Silumm"] = {						--111
		
	},
	["Mines of Khuras"] = {			--228
		
	},
	["Enduum"] = {						--203
		
	},
	["Ebon Crypt"] = {				--215
		
	},
	["Cryptwatch Fort"] = {			--235
		
	},
	["Bad Man's Hallows"] = {		--65 (has more floors, mapIDs: 65,98,99)
		
	},

----Grahtwood (Aldmeri, lvl 16-23)
	["Grahtwood"] = {					--9
		
	},
	["Haven"] = {					--512
		
	},
	["Elden Root"] = {			--445
		
	},
	["Ne Salas"] = {				--404
	
	},
	["The Scuttle Pit"] = {		--394
		
	},
	["Burroot Kwama Mine"] = {	--396
		
	},
	["Vinedeath Cave"] = {		--393
		
	},
	["Wormroot Depths"] = {		--414
		
	},
	["Mobar Mine"] = {			--395
		
	},
	["Root Sunder Ruins"] = {	--283
		
	},

----Greenshade (Aldmeri lvl 25-30)
	["Greenshade"] = {			--300
		
	},
	["Marbruk"] = {				--387
		
	},
	["Woodhearth"] = {				--529
		{0.48, 0.7, "Adaishir", 27},
		{0.24, 0.42, "Zaheida", 27},
	},
	["Gurzags Mine"] = {		--382
	
	},
	["Carac Dena"] = {			--386
		
	},
	["Naril Nagaia"] = {			--391
		
	},
	["The Underroot"] = {		--384
		
	},
	["Harridans Lair"] = {		--383
		
	},
	["Barrow Trench"] = {		--380
		
	},
	["Rulanyils Fall"] = {		--278
		
	},

----Khenarthi's Roost (Aldmeri, lvl 1-5)
	["Khenarthi's Roost"] = {	--258
		{0.53, 0.8, "Snarga", 27},
	},
	["Mistral"] = {				--567
		{0.56, 0.48, "Jurairia", 27},
	},

----Malabal Tor (Aldmeri, lvl 31-37)
	["Malabal Tor"] = {			--22
		{0.25, 0.56, "Guilion", 27},
		{0.77, 0.47, "Tellanil", 27},
		{0.72, 0.64, "Rithros", 27},
	},
	["Vulkwasten"] = {			--534
		{0.49, 0.62, "Berriza", 27},
	},
	["Black Vine Ruins"] = {	--199
		
	},
	["Dead Mans Drop"] = {		--222
		
	},
	["Hoarvor Pit"] = {			--262
		
	},
	["Roots of Silvenar"] = {	--267
		
	},
	["Shael Ruins"] = {			--260
		
	},
	["Tomb of the Apostates"] = { --221
		
	},
	["Crimson Cove"] = {			--175
		
	},
							
----Reaper's March (Aldmeri, lvl 37-43)
	["Reaper's March"] = {		--256
		{0.27, 0.31, "Haldwyn", 27},
	},
	["Dune"] = {					--533
	    {0.17, 0.5, "Mazduni-Daro", 27},
	},
	["Kuna's Delve"] = {			--343
		
	},
	["Thibauts Cairn"] = {		--323
	
	},
	["Weeping Wind Cave"] = {	--307
		
	},
	["Claw's Strike"] = {		--301
		
	},
	["Fardir's Folly"] = {		--210
		
	},
	["Jode's Light"] = {			--304
		
	},
	["The Vile Manse"] = {		--317  (this dungeon has more floors, mapIDs: 317,318)  
		
	},

----Rivenspire (Daggerfall, lvl 25-30)
	["Rivenspire"] = {			--10
		
	},
	["Stornhelm"] = {				--85
		
	},
	["Northpoint"] = {			--513
		
	},
	["Crestshade Mine"] = {		--225
		
	},
	["Erokii Ruins"] = {			--204
		
	},
	["Flyleaf Catacombs"] = {	--216
		
	},
	["Hildune's Secret Refuge"] = { --244
		
	},
	["Orc's Finger Ruins"] = {	--200
		
	},
	["Tribulation Crypt "] = {	--220
		
	},
	["Obsidian Scar"] = {		--42
		
	},
			
----Shadowfen (Ebonheart, lvl 25-30)
	["Shadowfen"] = {				--26
		{0.61, 0.36, "Blue-Scale", 27, 13, 50}, 
		{0.51, 0.25, "Blue-Scale", 27, 13, 51}, 
		{0.2568, 0.6368, "Abijoo-Anoo", 27, 13, 52},
		{0.3351, 0.7144, "Abijoo-Anoo", 27, 13, 53},
		{0.36, 0.71, "Chalaree", 27, 9},
		{0.46, 0.39, "Vagar Crag-Carver", 27},
		{0.25, 0.36, "Ulster", 27, 20},
		{0.41, 0.2, "Doubts-the-Moon", 27, "Replaced at quest end"},
		{0.42, 0.2, "Dusk-Scale", 27, "Replaces Doubts-the-Moon"},
	},
	["Stormhold"] = {				--217
		{0.88, 0.35, "Blue-Scale", 27, 13, 51},
	},
	["Alten Corimont"] = {		--544
		{0.51, 0.49, "Ottaesa", 27},
	},
	["Atanaz Ruins"] = {			--146
		
	},
	["Broken Tusk"] = {			--155
		
	},
	["Chid-Moska Ruins"] = {	--148
		
	},
	["Gandranen Ruins"] = {		--150
		
	},
	["Onkobra Kwama Mine"] = {	--147
		
	},
	["Shrine of the Black Maw"] = { --149
		
	},
	["Sanguine's Demesne"] = {
		
	},

--Stonefalls (Ebonheart, lvl 5-15)
	["Stonefalls"] = {			--7
	    { 0.42, 0.57, "lo-lo", 27, 13, 5},
		{ 0.48, 0.53, "lo-lo", 27, 13}, 
		{ 0.52, 0.54, "lo-lo", 27, 13, 7},
		{ 0.21, 0.34, "Wemeerit", 27, 13, 12},
		{ 0.20, 0.36, "Wemeerit", 27, 13},
		{ 0.20, 0.39, "Wemeerit", 27, 13},
	    { 0.19, 0.42, "Wemeerit", 27, 13, 11},
		{ 0.23, 0.38, "Beshnus", 27, 13, 14},
		{ 0.24, 0.39, "Beshnus", 27, 13},
		{ 0.25, 0.41, "Beshnus", 27, 13},
		{ 0.28, 0.42, "Beshnus", 27, 13},
		{ 0.30, 0.45, "Beshnus", 27, 13, 15},
		{ 0.58, 0.53, "Lathisa Heryon", 27, 13, 16},
		{ 0.67, 0.53, "Lathisa Heryon", 27, 13},
		{ 0.72, 0.58, "Lathisa Heryon", 27, 13},
		{ 0.72, 0.55, "Lathisa Heryon", 27, 13, 5},
		{ 0.85, 0.45, "Arendil Indrano", 27, 13, 17},
		{ 0.87, 0.45, "Arendil Indrano", 27, 13},
		{ 0.85, 0.38, "Arendil Indrano", 27, 13, 6},
		{ 0.23, 0.26, "Bendyni Nelvani", 27},
    },
	["Ebonheart"] = {
	     { 0.38, 0.80, "lo-lo", 27, 13, 7}, 
		 { 0.53, 0.64, "Mendyn Indrano", 27}, 
		 { 0.66, 0.74, "Lathisa Heryon", 27, 13, 16}, 
	},
	["Kragenmoor"] = {
		 { 0.56, 0.45, "Kaasha", 27},
		 { 0.48, 0.40, "Aryvena Lathoril", 27, 8, 9},
	},
	["Davon's Watch"] = {		--24
		 { 0.55, 0.69, "Fetches-Glitter", 27},
		 { 0.46, 0.62, "Hedstild", 27},
		 { 0.48, 0.75, "Arendil Indrano", 27, 13},
		 { 0.45, 0.69, "Arendil Indrano", 27, 13, 6},
	},
    ["Inner Sea Armature"] = {	--90
		
	},
	["Emberflint Mine"] = {		--112
		
	},
	["Mephala's Nest"] = {		--114
		
	},
	["Softloam Cavern"] = {		--110
		
	},
	["Hightide Hollows"] = {	--97
		
	},
	["Sheogorath's Tongue"] = { --113
		
	},
	["Crow's Wood"] = {			--72
		
	},

----Stormhaven (Daggerfall, lvl 16-23)
	["Stormhaven"] = {			--12
		
	},
	["Bearclaw Mine"] = {		--223
		
	},
	["Farangel's Delve"] = {	--249
		
	},
	["Koeglin Mine"] = {			--202
		
	},
	["Norvulk Ruins"] = {		--194
		
	},
	["Pariah Catacombs"] = {	--219
		
	},
	["Portdun Watch"] = {		--238
	
	},
	["Bonesnap Ruins"] = {		--189
		
	},

----Stros M'Kai (Daggerfall, lvl 1-5)
    ["Stros M'Kai"] = {			--201
		
	},
	["Port Hunding"] = {			--530
		
	},

----The Rift (Ebonheart, lvl 37-43)
	["The Rift"] = {				--125
	
	},
	["Shor's Stone"] = {			--542
		 { 0.53, 0.54, "Jazeez-Geel", 27, 8, 9},
	},
	["Avanchnzel"] = {			--169
		
	},
	["Faldar's Tooth"] = {		--214
		
	},
	["Fort Greenwall"] = {		--254
		
	},
	["Shroud Hearth Barrow"] = { --211
		
	},
	["Snapleg Cave"] = {			--265
		
	},
	["The Lion's Den"] = {		--142
		
	},
		["Nimalten"] = {		--142
		 {0.56, 0.42, "Frerbild", 27},
	},
	["Riften"] = {		--142
		 {0.49, 0.64, "Shishiv", 27},
		 {0.57, 0.63, "J'darzi", 27},
	},
	["Baandari Trading Post"] = {
	    {0.64, 0.42, "Jainda", 27},
	},
	["Redfur Trading Post"] = {
	    {0.67, 0.42, "Fanayell", 27},
	},	
}